﻿Type=Class
Version=6.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'version: 1.00
#Event: FileUploaded(FileID as string)
#Event: FileDownloaded

Sub Class_Globals
	Dim  AccessToken As String
	Dim DriveListLink As String : DriveListLink = "https://www.googleapis.com/drive/v2/files"
	Dim DriveUploadLink As String : DriveUploadLink = "https://www.googleapis.com/upload/drive/v2/files"
	
	Dim  Upload, GetFileList, Download As HttpJob
	Dim FileId, DownLoadUrl As String : FileId = ""
	Dim FileMetaData As Map
	
	'File list is downloaded in pages of MaxResults number of files
	Dim MaxResults As Int : MaxResults = 10  ' Very low number for test purposes
	Dim FileListResult As String
	Private evName As String
	Private evModule As Object
	Dim Title As String 
	Dim  LocalDir As String 
	Dim LocalFileName As String 
	Dim Opcao As String 
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(CallbackModule As Object, cEventname As String, vAccessToken As String	)
	evModule = CallbackModule
	evName = cEventname
    AccessToken= vAccessToken
End Sub
Sub UploadFile(vTitle As String, vLocalDir As String, vLocalFileName As String)
	Title = vTitle 
	LocalDir = vLocalDir 
	LocalFileName=vLocalFileName
	FileId = ""
	DownLoadUrl  = ""
	FileListResult = ""
	Opcao = "Upload"
	GetFileList.Initialize ("GetFileList", Me)	
	GetFileList.Download(DriveListLink & "?access_token=" & AccessToken & "&q=trashed+%3D+false&maxResults=" & MaxResults)
End Sub

Sub DownloadFile(vLocalPath As String, vtitle As String)
	Title=vtitle 
	LocalDir = vLocalPath
	LocalFileName=""
	FileId = ""
	DownLoadUrl  = ""
	FileListResult = ""
	Opcao = "Download"
	GetFileList.Initialize ("GetFileList", Me)	
	GetFileList.Download(DriveListLink & "?access_token=" & AccessToken & "&q=trashed+%3D+false&maxResults=" & MaxResults)
End Sub

Sub JobDone (Job As HttpJob)
	ProgressDialogHide
	Select Job.JobName
		Case "FileUpload"				
			If Upload.Success Then
				Dim J As JSONParser
				J.Initialize(Upload.GetString)
				FileMetaData = J.NextObject
				FileId = FileMetaData.Get("id")
				DownLoadUrl = FileMetaData.Get("downloadUrl")
'				Log ("STRING " & Upload.GetString)
				CallSub2(evModule, evName & "_FileUploaded", FileId)
			Else
				ToastMessageShow("Error Uploading", True)
				Log ("ERROR " & Upload.ErrorMessage)
			End If
		Case "GetFileList"
			If GetFileList.Success Then
'				Log ("STRING " & GetFileList.GetString)
				ShowFileList
			Else
				ToastMessageShow("Error Getting File List", True)
				ToastMessageShow("Tente novamente", True)
				Log ("ERROR " & GetFileList.ErrorMessage)
			End If
			
		Case "Download"
			If Download.Success Then
				SaveFile
	'			Log ("STRING " & Download.GetString)
			Else
				ToastMessageShow("Error Downloading File", True)
				Log ("ERROR " & Download.ErrorMessage)
			End If
	End Select

End Sub

Sub ShowFileList
	Dim Map1, fileEntry As Map
	Dim J As JSONParser
	J.Initialize(GetFileList.GetString)
	Map1 = J.NextObject
    Dim files As List
	files = Map1.Get("items")
	For i = 0 To files.Size - 1
		fileEntry = files.Get(i)
		If fileEntry.get("title") = Title Then 
			If FileListResult <> "" Then
				FileListResult = FileListResult & CRLF
			End If
			FileListResult = FileListResult & QUOTE & fileEntry.Get("title") & QUOTE & " >> " & fileEntry.Get("mimeType") & " >> " & fileEntry.Get("id") & fileEntry.Get("modifiedDate")
			FileId = fileEntry.Get("id")
			DownLoadUrl  = fileEntry.Get("downloadUrl")
			Log (fileEntry.Get("title") & " " &  fileEntry.Get("id") & " "& fileEntry.Get("modifiedDate"))
			FileMetaData=Map1
			
			If Opcao = "Upload" Then 
				CargaArquivo 
			Else
				BaixaArquivo
			End If 
			
			Return 		
		End If 
	Next
	Dim nextLink As String
	nextLink = Map1.Get("nextLink")
	If nextLink <> Null And nextLink <> "null" Then
		GetFileList.Initialize("GetFileList", Me)
		GetFileList.Download(nextLink & "&access_token=" & AccessToken)
	Else
		If Opcao = "Upload" Then 
			CargaArquivo 
		Else
			ToastMessageShow("Erro arquivo nao encontrado para Download",True)
		End If 
	End If
End Sub

Sub SaveFile
	Dim FN As String
	FN = Title 
	Dim inStr As InputStream
	Dim out As OutputStream
	inStr = Download.GetInputStream
	out = File.OpenOutput(LocalDir, FN, False)
	File.Copy2(inStr, out)
	out.Close
	If SubExists(evModule, evName & "_FileDownloaded") Then CallSub(evModule, evName & "_FileDownloaded")	
End Sub

Sub CargaArquivo	
	Dim Dir, FN As String
	Dir = LocalDir
	
	FN = LocalFileName
	Title = Title
	
	'The boundary can be any word you choose.   
	Dim boundary As String
	boundary = "***bound***"
	
	Dim In As InputStream = File.OpenInput(Dir, FN)
    Dim out2 As OutputStream
    out2.InitializeToBytesArray(1000)
   
    Dim J As JSONGenerator
	If FileId = "" Then
	    Dim m As Map
	    m.Initialize
	    m.Put("title", Title)
    	J.Initialize(m)   
	Else
	    FileMetaData.Put("title", Title)
		J.Initialize(FileMetaData)
	End If

    Dim FileName As String = FN
    FileName = FileName.SubString(FileName.LastIndexOf(".")+1)
    Dim ContentType As String
    Dim Suffix As Object = FileName   
    Select Suffix
        Case "jpg"
            ContentType = "image/jpeg"
        Case "xls"
            ContentType = "application/vnd.ms-excel"
        Case "csv"
            ContentType = "text/csv"
		Case Else
			ContentType = "application/octet-stream"
    End Select

    Dim data() As Byte
	
	'The first half of the POST contains the JSON data AND the Content Type from above.
    data = ("--" & boundary & CRLF & "Content-Type: application/json; charset=UTF-8" & CRLF & CRLF & J.ToString & CRLF & CRLF & "--" & boundary & CRLF & "Content-Type: " & ContentType & CRLF & CRLF).GetBytes("UTF-8")
	'Write it To the Stream.
    out2.WriteBytes(data, 0, data.Length)
	'Add the File itself To the Stream.   
    File.Copy2(In, out2)
	'out2.WriteBytes("FILE DATA".GetBytes("UTF-8"),0,"FILE DATA".GetBytes("UTF-8").Length)
	'Add the final boundary to the POST
    data = (CRLF & CRLF & "--" & boundary & "--").GetBytes("UTF-8")
	'Write it To the Stream Then make the Bytes the complete Stream.
    out2.WriteBytes(data, 0, data.Length)
	    data = out2.ToBytesArray
	
	'POST the Bytes and change the Content Type.
	Upload.Initialize ("FileUpload", Me)
	
	If FileId = "" Then
	    Upload.PostBytes(DriveUploadLink & "?uploadType=multipart", data)
	    Upload.GetRequest.SetContentType("multipart/related; boundary=" & boundary)
	    Upload.GetRequest.SetHeader("Authorization", "Bearer " & AccessToken)
	Else
	    Upload.PutBytes(DriveUploadLink & "/" & FileId, data)
	    Upload.GetRequest.SetContentType("multipart/related; boundary=" & boundary)
    	Upload.GetRequest.SetHeader("Authorization", "Bearer " & AccessToken)
	End If
End Sub

Sub BaixaArquivo
	Download.Initialize ("Download", Me)	
	Download.Download(DownLoadUrl & "&access_token=" & AccessToken)
End Sub
